#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "dispatch4xi.py">
#<abstract4xi abstract = " provides function dispatch4xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
                          

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'dispatch4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    import array
    import queue
    from traceback import format_exc         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                            
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import dispatch
except:
    print("dispatch4xi.py *** failed in from multiprocessing.managers import dispatch ***")
#"
#/>
 

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from convert_to_error4xi import convert_to_error4xi
from constant_managers4xi import get_return_manager4xi
from constant_managers4xi import get_shutdown_manager4xi    
from print4xi import print4xi
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "dispatch4xi function" usage = "
# 
# for communication with a manager's server process 
#   managers.py
#       connect(self)
#           conn = Client(self._address, self._authkey)
#           dispatch(conn, None, 'dummy')
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def dispatch4xi(c, id, methodname, args=(), kwds={}):

    '''
    dispatch4xi function: sends a message to manager using connection `c` and return response
    '''
                
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    class2xi = "dispatch4xi"
    method2xi = "dispatch4xi"
    
    message2print = "{started" + "; dispatch4xi-started: " + str(dispatch4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{passed" + "; connection-passed-to-dispatch4xi: " + str(c) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; id-passed-to-dispatch4xi: " + str(id) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; methodname-passed-to-dispatch4xi: " + str(methodname) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; args-passed-to-dispatch4xi: " + str(args) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; kwds-passed-to-dispatch4xi: " + str(kwds) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
        
    # { dispatch4xi : dispatch4xi ; c: None; id: None; methodname: create; args: ('dict',); kwds: {}; time: 18:21:09 06/23/09 FLE Daylight Time}

    
    # ---------------------------------------------------------------------------------------------
    #
    # ---------------------------------------------------------------------------------------------      
    
    if c is None:
        message2print = "{warning" + "; connection-warning-by-dispatch4xi: " + " ** " + str(c)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     

    
    # ---------------------------------------------------------------------------------------------
    #
    # ---------------------------------------------------------------------------------------------      
        
    try:
        message2print = "{(Step 2/12a) sending; id-to-be-sent-by-dispatch4xi: " + str(id) + "; time: " + time4xi() + "}"
        print4xi(class2xi, method2xi, message2print)
        
        message2print = "{(Step 2/12b) sending; method-to-be-sent-by-dispatch4xi: " + str(methodname) + " ; time: " + time4xi() + "}"
        print4xi(class2xi, method2xi, message2print)         
        
        c.send((id, methodname, args, kwds))
        
        message2print = "{(Step 3/12) sent; method-sent-by-dispatch4xi: " + str(methodname) + "; time: " + time4xi() + "}"
        print4xi(class2xi, method2xi, message2print)         
        
    except:
        message2print = "{(Step 4/12) hit; exception-hit-by-dispatch4xi: " + "*** error in c.send ***" + " ; time: " + time4xi() + "}"
        print4xi(class2xi, method2xi, message2print)     
    
    # ---------------------------------------------------------------------------------------------
    #
    # ---------------------------------------------------------------------------------------------      
         
    
    try:
        message2print = "{(Step 5/12) calling; function-calling-by-dispatch4xi: c.recv; time: " + time4xi() + "}"
        print4xi(class2xi, method2xi, message2print)         
        
        kind2xi, result2xi = c.recv()
 
        message2print = "{(Step 6/12a) received; kind2xi-received-by-dispatch4xi: " + str(kind2xi) + "; time: " + time4xi() + "}"
        print4xi(class2xi, method2xi, message2print)             
        
        message2print = "{(Step 6/12b) received; result2xi-received-by-dispatch4xi: " + str(result2xi) + "; time: " + time4xi() + "}"
        print4xi(class2xi, method2xi, message2print)          
        
        if kind2xi == get_return_manager4xi(): #RETURN_MANAGER4XI
            message2print = "{(Step 7/12) returning; result2xi-returning-by-dispatch4xi: " + str(result2xi) + ";time: " + time4xi() + "}"
            print4xi(class2xi, method2xi, message2print)     
            
            return result2xi
        else:
            message2print = "{(Step 8/12) hit; error-kind2xi-hit-by-dispatch4xi: " + str(kind2xi) + "; time: " + time4xi() + "}"
            print4xi(class2xi, method2xi, message2print)     

            message2print = "{(Step 9/12) hit; error-none-hit-by-dispatch4xi: " + "*** returning None ***; time: " + time4xi() + "}"
            print4xi(class2xi, method2xi, message2print)              
                        
    except:
            message2print = "{(Step 10/12) hit; exception-hit-by-dispatch4xi: " + "*** failed in c.recv; time: " + time4xi() + "}"
            print4xi(class2xi, method2xi, message2print)               
            

    # ---------------------------------------------------------------------------------------------
    #
    # ---------------------------------------------------------------------------------------------      
    message2print = "{(Step 12/12) raising; error-result2xi-raising-by-dispatch4xi:" + str(result2xi) + "; time: " + time4xi() + "}"
    print4xi(class2xi, method2xi, message2print)       
    
    raise convert_to_error4xi(kind2xi, result2xi)
#</function4xi> 

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of dispatch4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



